<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<div
  *ngIf="workspace$ | async as workspace"
  fxLayout="column"
  fxFlexFill
  class="wrapper-content"
>
  <div fxFlex class="content">
    <div fxLayout="column" fxLayoutGap="20px">

      <mat-card>
        <mat-card-title class="light-bold">Short Description</mat-card-title>

        <mat-card-content
          *ngIf="!isEditingDescriptions; else shortDescriptionEdit"
          fxLayout="column"
          class="workspace-short-description"
        >
          <div *ngIf="workspace.shortDescription; else noShortDescription" fxFlexFill class="short-description">
            <span fxFlex class="short-description-text">{{ workspace.shortDescription }}</span>
          </div>
          <ng-template #noShortDescription>
            <app-message
              type="info"
              msg="This workspace doesn't have any short description."
              [isClosable]="false"
              class="info-no-short-description"
            ></app-message>
          </ng-template>
        </mat-card-content>

        <ng-template #shortDescriptionEdit>
          <mat-card-content fxLayout="column">
            <div fxFlexFill class="workspace-short-description-edit">
              <mat-form-field appearance="outline" fxFlexFill class="short-description-form-field">
                <textarea
                  #txtShortDescription
                  matInput
                  matTextareaAutosize
                  maxLength="200"
                  placeholder="Add short description to the current workspace"
                  [appFocusInputIfLargeScreen]="isFocusShortDescriptionTextarea"
                  [disabled]="isSettingDescriptions"
                  [(ngModel)]="shortDescription"
                  class="short-description-wks"
                ></textarea>
                <mat-hint *ngIf="txtShortDescription.value?.length !== 200; else isMaxLength">
                  {{ txtShortDescription.value?.length || 0 }}/200</mat-hint>
                <ng-template #isMaxLength>
                  <mat-error>Max 200 characters!</mat-error>
                </ng-template>
              </mat-form-field>
            </div>
          </mat-card-content>
        </ng-template>

        <mat-card-title class="light-bold margin-top-x1">Description</mat-card-title>

        <mat-card-content
          *ngIf="!isEditingDescriptions; else descriptionEdit"
          fxLayout="column"
          class="workspace-description">
          <div *ngIf="workspace.description; else noDescription" fxFlexFill class="description">
            <span fxFlex [innerHTML]="workspace.description | MarkdownToHtml" class="description-text"></span>
          </div>
          <ng-template #noDescription>
            <app-message
              type="info"
              msg="This workspace doesn't have any description."
              [isClosable]="false"
              class="info-no-description margin-bottom-x2"
            ></app-message>
          </ng-template>
        </mat-card-content>

        <ng-template #descriptionEdit>
          <mat-card-content fxLayout="column">
            <div fxFlexFill class="workspace-description-edit">
              <mat-form-field appearance="outline" fxFlexFill class="description-form-field">
                <textarea
                  matInput
                  matTextareaAutosize
                  placeholder="Add description to the current workspace"
                  [disabled]="isSettingDescriptions"
                  [(ngModel)]="description"
                  class="description-wks"
                ></textarea>
                <mat-hint>Supports Standard Markdown Syntax</mat-hint>
              </mat-form-field>
              <div fxFlexFill>
                <span
                  *ngIf="description; else nothingToPreview"
                  fxFlex [innerHTML]="description | MarkdownToHtml"
                  class="workspace-description-preview padding-x1"
                ></span>
                <ng-template #nothingToPreview>
                  <div fxFlexFill fxFlex class="msg-no-description padding-x1">Nothing to preview</div>
                </ng-template>
              </div>
            </div>
          </mat-card-content>
        </ng-template>

        <mat-card-actions
          *ngIf="!isEditingDescriptions; else descriptionsBtnEdit"
          fxFlexFill
          fxLayoutAlign="end center"
        >
          <button
            mat-raised-button type="button"
            color="primary"
            (click)="editDescriptions()"
            class="btn-add-edit-descriptions text-upper margin-right-x1"
          >
            <span
              *ngIf="(workspace.description.length || workspace.shortDescription.length); else addDescriptions"
              fxLayout="row"
              fxLayoutAlign="start center"
            >
              <mat-icon class="margin-right-x1">edit</mat-icon>
              <span class="edit-text-btn">Edit</span>
            </span>
            <ng-template #addDescriptions>
              <span fxLayout="row" fxLayoutAlign="start center">
                <mat-icon class="margin-right-x1">add</mat-icon>
                <span class="add-text-btn">Add</span>
              </span>
            </ng-template>
          </button>
          <button
            mat-raised-button
            type="button"
            color="warn"
            (click)="openDeletionDialog()"
            [disabled]="workspace.isRemoving || isRemoving"
            class="btn-delete-wks"
          >
            <span fxLayout="row" fxLayoutAlign="start center">
              <mat-icon class="margin-right-x1">delete</mat-icon>
              <span class="text-upper">Delete this workspace</span>
            </span>
          </button>
        </mat-card-actions>

        <ng-template #descriptionsBtnEdit>
          <mat-card-actions *ngIf="isEditingDescriptions" fxFlexFill fxLayoutAlign="end center">
            <button
              mat-button
              type="button"
              color="primary"
              [disabled]="isSettingDescriptions"
              (click)="cancelDescriptions()"
              class="btn-cancel-descriptions text-upper margin-right-x1"
            >
              Cancel
            </button>
            <button
              mat-raised-button
              type="button"
              color="primary"
              (click)="saveDescriptions()"
              [disabled]="isSettingDescriptions || (description === workspace.description && shortDescription === workspace.shortDescription)"
              class="btn-save-descriptions text-upper"
            >
              <span fxLayout="row" fxLayoutAlign="start center">
                <fa-icon class="margin-right-x1 icon-x2" icon="check"></fa-icon>
                <span class="text-upper">Save</span>
              </span>
            </button>
          </mat-card-actions>
        </ng-template>

      </mat-card>

      <mat-card *ngIf="buses$ | async as buses" class="card-buses">
        <mat-card-title class="light-bold">Bus list</mat-card-title>
        <mat-card-content fxLayout="column">
          <div
            *ngIf="buses.list.length; else noBuses"
            fxLayout="row wrap"
            fxLayout.lt-sm="column"
            fxLayoutGap="24px grid"
            fxLayoutAlign="flex-start"
            class="bus-grid-item"
          >
            <div
              *ngFor="let bus of buses.list"
              fxFlex="0 1 calc(12.5% - 24px)"
              fxFlex.lt-md="0 1 calc(50% - 24px)"
              class="bus-item"
            >
              <a
                *ngIf="!isEditingBusList && !bus.isBusSelectedForDetachment"
                gdAreas="content | footer"
                gdRows="60px 36px"
                matTooltip="Go to this bus"
                matTooltipPosition="below"
                [routerLink]="['/workspaces', workspace.id, 'petals', 'buses', bus.id]"
                class="bus-link"
              >
                <div
                  gdArea="content"
                  fxLayout="row"
                  fxLayoutAlign="center center"
                  class="bus-svg-content"
                >
                  <mat-icon color="primary" svgIcon="bus" class="padding-x2"></mat-icon>
                </div>
                <div
                  gdArea="footer"
                  fxLayout="row"
                  fxLayoutAlign="start center"
                  class="bus-footer"
                >
                  <span class="bus-name">{{ bus.name }}</span>
                </div>
              </a>

              <ng-template #detachInProgress [ngIf]="isBusDetaching() && bus.isBusSelectedForDetachment">
                <div fxLayout="row" fxLayoutAlign="center center" class="margin-top-x2">
                  <mat-spinner
                    color="primary"
                    [diameter]="32"
                    [strokeWidth]="2"
                    class="detach-spinner"
                  ></mat-spinner>
                </div>
              </ng-template>

              <ng-template #detachBusEdit [ngIf]="isEditingBusList">
                <a
                  gdAreas="content | footer"
                  gdAreas.lt-md="content | footer"
                  gdRows="60px 36px"
                  matTooltipPosition="below"
                  [matTooltip]="bus.isBusSelectedForDetachment ? 'Unselect this bus' : 'Select this bus'"
                  (click)="toggleSelectDetachBus(bus.id)"
                  class="bus-detach"
                >
                  <div
                    gdArea="content"
                    fxLayout="row"
                    fxLayoutAlign="center center"
                    [ngClass]="{'active': bus.isBusSelectedForDetachment}"
                    class="bus-svg-content"
                  >
                    <mat-icon color="primary" svgIcon="bus" class="padding-x2"></mat-icon>
                    <fa-icon class="margin-right-x1 icon-x4" icon="unlink"></fa-icon>
                  </div>
                  <div
                    gdArea="footer"
                    fxLayout="row"
                    fxLayoutAlign="start center"
                    class="bus-footer"
                  >
                    <span class="bus-name">{{ bus.name }}</span>
                  </div>
                </a>
              </ng-template>
            </div>
          </div>

          <ng-template #noBuses>
            <app-message
              type="info"
              msg="There are no buses attached to this workspace."
              [isClosable]="false"
              class="info-no-buses"
            ></app-message>
          </ng-template>
        </mat-card-content>

        <form class="bus-import-form" novalidate (ngSubmit)="onSubmit(busImportForm)" [formGroup]="busImportForm">
          <div *ngIf="isEditingImportBus" class="margin-top-x2">
            <mat-card-title class="light-bold">Import bus details</mat-card-title>

            <mat-card-content>
              <div
                fxLayout="row wrap"
                fxLayout.lt-sm="column"
                fxLayoutGap="24px grid"
                fxLayoutGap.xs="0 grid"
                class="bus-import-edit"
              >
                <mat-form-field
                  appearance="outline"
                  floatLabel="always"
                  fxFlex="36%"
                  class="ip-form-field"
                >
                  <mat-label>IP or hostname</mat-label>
                  <input
                    type="text"
                    placeholder="{{formDefault.ip}}"
                    matInput
                    appFocusInputIfLargeScreen
                    formControlName="ip"
                  >
                  <span matPrefix>
                    <fa-icon icon="map-marker-alt" class="icon-x2"></fa-icon>
                  </span>
                </mat-form-field>

                <mat-form-field
                  appearance="outline"
                  floatLabel="always"
                  fxFlex="28%"
                  class="port-form-field"
                >
                  <mat-label>Port</mat-label>
                  <input
                    matInput
                    type="text"
                    placeholder="{{ formDefault.port }}"
                    formControlName="port"
                    [errorStateMatcher]="importBusMatcher"
                  >
                  <span matPrefix>
                    <fa-icon icon="ethernet" class="icon-x2"></fa-icon>
                  </span>
                  <mat-error *ngIf="formErrors.port">
                    {{ formErrors.port }}
                  </mat-error>
                </mat-form-field>

                <mat-form-field
                  appearance="outline"
                  floatLabel="always"
                  fxFlex="36%"
                  class="username-form-field"
                >
                  <mat-label>Username</mat-label>
                  <input
                    matInput
                    type="text"
                    placeholder="{{formDefault.username}}"
                    formControlName="username"
                  >
                  <span matPrefix>
                    <fa-icon icon="id-badge" class="icon-x2"></fa-icon>
                  </span>
                </mat-form-field>

                <mat-form-field
                  appearance="outline"
                  floatLabel="always"
                  fxFlex="36%"
                  [ngClass.gt-xs]="'pwd-form-field'"
                  class="pwd-form-field"
                >
                  <mat-label>Password</mat-label>
                  <input type="password" placeholder="{{formDefault.password}}" matInput formControlName="password">
                  <span matPrefix>
                    <fa-icon icon="key" class="icon-x2"></fa-icon>
                  </span>
                </mat-form-field>

                <mat-form-field
                  appearance="outline"
                  floatLabel="always"
                  fxFlex="64%"
                  [ngClass.gt-xs]="'passphrase-form-field'"
                  class="passphrase-form-field"
                >
                  <mat-label>Topology passphrase</mat-label>
                  <input
                    matInput
                    type="password"
                    placeholder="{{formDefault.passphrase}}"
                    formControlName="passphrase"
                  >
                  <span matPrefix>
                    <fa-icon icon="shield-alt" class="icon-x2"></fa-icon>
                  </span>
                </mat-form-field>
              </div>

              <app-message
                type="error"
                [msg]="getError()"
                [isFullWidth]="true"
                class="error-import-details"
              ></app-message>
            </mat-card-content>
          </div>

          <mat-card-actions fxFlexFill fxLayoutAlign="end center">
            <!-- Attach Bus -->
            <button
              *ngIf="!isEditingImportBus && !isEditingBusList; else attachBusBtnEdit"
              mat-raised-button
              type="button"
              color="primary"
              (click)="editAttachBus()"
              class="btn-import-bus margin-right-x1 text-upper"
            >
              <span fxLayout="row" fxLayoutAlign="start center">
                <fa-icon icon="link" class="margin-right-x1 icon-x1"></fa-icon>
                <span class="attach-bus-text-btn">Attach Bus</span>
              </span>
            </button>
            <ng-template #attachBusBtnEdit>
              <button
                *ngIf="isEditingImportBus"
                mat-button
                type="button"
                color="primary"
                [disabled]="disabledCancelBtn || isImportingBus || importBusId"
                (click)="cancelAttachBus()"
                class="btn-cancel-attach-bus text-upper margin-right-x1"
              >
                Cancel
              </button>
              <button
                *ngIf="isEditingImportBus"
                mat-raised-button
                type="submit"
                color="primary"
                [disabled]="disabledAttachBtn || busImportForm.invalid || isImportingBus || importBusId"
                class="btn-import-new-bus text-upper"
              >
                <span *ngIf="isImportingBus; else canImport" fxLayout="row" fxLayoutAlign="start center">
                  <mat-spinner [diameter]="16" [strokeWidth]="1" class="margin-right-x1"></mat-spinner>
                  Importing
                </span>

                <ng-template #canImport>
                  <fa-icon icon="check" class="margin-right-x1 icon-x2"></fa-icon>
                  <span class="text-upper import-bus-text-btn">Import</span>
                </ng-template>
              </button>
            </ng-template>

            <!-- Detach Bus -->
            <button
              *ngIf="!isEditingBusList && !isEditingImportBus && buses.list.length && !isBusDetaching(); else detachBusBtnEdit"
              mat-raised-button
              type="button"
              color="accent"
              (click)="editDetachBus()"
              class="btn-detach-bus margin-right-x1 text-upper"
            >
              <span fxLayout="row" fxLayoutAlign="start center">
                <fa-icon icon="unlink" class="margin-right-x1 icon-x1"></fa-icon>
                <span class="detach-bus-text-btn">Detach Bus</span>
              </span>
            </button>
            <ng-template #detachBusBtnEdit>
              <button
                *ngIf="isEditingBusList"
                mat-button
                type="button"
                color="primary"
                (click)="cancelDetachBus()"
                class="btn-cancel-detach-bus text-upper margin-right-x1"
              >
                Cancel
              </button>
              <button
                *ngIf="isEditingBusList"
                mat-raised-button
                type="button"
                color="primary"
                [disabled]="disabledDetachBtn || !isBusSelectedForDetachment()"
                (click)="openDetachBusDialog()"
                class="btn-open-detach-bus-dialog text-upper"
              >
                <span fxLayout="row" fxLayoutAlign="start center">
                  <fa-icon icon="check" class="margin-right-x1 icon-x2"></fa-icon>
                  <span class="text-upper detach-bus-text-btn">Detach</span>
                </span>
              </button>
            </ng-template>
          </mat-card-actions>
        </form>
      </mat-card>

      <mat-card fxFlex fxLayout="column" class="card-users">
        <mat-card-title class="light-bold">Users</mat-card-title>

        <mat-card-content *ngIf="users$ | async as users" fxLayout="column" class="workspace-users">
          <app-message
            *ngIf="users.length === 1; else workspaceShared"
            type="info"
            msg="You are the only one using this workspace."
            [isClosable]="false"
            class="info-user-workspace"
          ></app-message>

          <ng-template #workspaceShared>
            <app-message
              type="info"
              msg="{{users.length}} people are using this workspace."
              [isClosable]="false"
              class="info-user-workspace-shared"
            ></app-message>
          </ng-template>

          <form [formGroup]="addUserFormGroup" class="margin-top-x1">
            <div fxLayout="row" fxLayoutAlign="start center">
              <mat-form-field
                appearance="outline"
                floatLabel="always"
                class="add-user-form-field margin-right-x1"
              >
                <mat-label>User to add</mat-label>
                <input
                  matInput
                  required
                  formControlName="userSearchCtrl"
                  [matAutocomplete]="autocompleteUsers"
                >
                <span matPrefix>
                  <mat-icon class="icon-x2">
                    <fa-icon icon="user-astronaut"></fa-icon>
                  </mat-icon>
                </span>
                <mat-error>Select a user on the list</mat-error>
              </mat-form-field>

              <mat-autocomplete #autocompleteUsers>
                <mat-option *ngFor="let filteredUser of filteredUsers$ | async" [value]="filteredUser">
                  {{ filteredUser }}
                </mat-option>
              </mat-autocomplete>
  
              <button
                mat-raised-button
                color="primary"
                [disabled]="addUserFormGroup.invalid || workspace.isAddingUserToWorkspace"
                (click)="addUser()"
                class="btn-add-user text-upper"
              >
                <span *ngIf="workspace.isAddingUserToWorkspace; else canAdd" fxLayout="row" fxLayoutAlign="start center">
                  Adding
                  <mat-spinner [diameter]="16" [strokeWidth]="1" class="margin-left-x1"></mat-spinner>
                </span>

                <ng-template #canAdd>
                  <span class="text-upper add-user-text-btn">Add</span>
                </ng-template>
              </button>
            </div>
          </form>

          <form [formGroup]="usersFormGroup" (ngSubmit)="onSubmitUsersPermissions()">
            <table
              *ngIf="currentUserId$ | async as currentUserId"
              mat-table
              matSort
              fxFlexFill
              formArrayName="usersFormArray"
              [dataSource]="usersFormArray.controls"
              class="users-table"
            >
              <!-- Name Column -->
              <ng-container matColumnDef="name">
                <th
                  mat-header-cell
                  *matHeaderCellDef
                  fxFlex="15"
                  fxLayoutAlign="start center"
                  class="mat-header-cell-user-name"
                >
                  Name
                </th>
                <td
                  *matCellDef="let user; let i = index;"
                  mat-cell
                  fxFlex="15"
                  fxLayout="row"
                  fxLayoutAlign="start center"
                  [formGroupName]="i"
                  class="cell-username-{{ user.value.id }}"
                >
                  <span fxFlexFill fxLayout="row" fxLayoutAlign="start center">
                    <app-generate-icon mat-list-avatar [size]="35" [text]="user.value.id"></app-generate-icon>
                    <span class="margin-left-x1 user-name ellipsis">{{ user.value.name }}</span>
                  </span>
                </td>
              </ng-container>

              <!-- Id Column -->
              <ng-container matColumnDef="id">
                <th
                  mat-header-cell
                  *matHeaderCellDef
                  fxFlex="15"
                  fxLayout="row"
                  fxLayoutAlign="center center"
                >
                  Id
                </th>
                <td
                  mat-cell
                  *matCellDef="let user; let i = index;"
                  fxFlex="15"
                  fxLayout="row"
                  fxLayoutAlign="center center"
                  [formGroupName]="i"
                  class="cell-userid-{{ user.value.id }}"
                >
                  <span class="user-id ellipsis">{{ user.value.id }}</span>
                </td>
              </ng-container>
              
              <!-- Permissions Columns -->
              <ng-container [matColumnDef]="permission.id" *ngFor="let permission of permissions;">
                <th
                  mat-header-cell
                  *matHeaderCellDef
                  fxFlex
                  fxLayout="row"
                  fxLayoutAlign="center center"
                >
                  {{ permission.label }}
                </th>
                <td
                  mat-cell
                  *matCellDef="let user; let i = index;"
                  fxFlex
                  fxLayout="row"
                  fxLayoutAlign="center center"
                  [formGroupName]="i"
                  class="cell-user-{{ permission.id }}-{{ user.value.id }}"
                >
                  <span 
                    *ngIf="isSavingUsersPermissions(users) && hasPermissionChanged(user.value.id, permission.id); else canCheck" 
                    fxLayout="row" 
                    fxLayoutAlign="start center"
                  >
                    <mat-spinner color="primary" [diameter]="16" [strokeWidth]="1"></mat-spinner>
                  </span>
                  
                  <ng-template #canCheck>
                    <mat-checkbox
                      [ngClass]="isUnchecked(users, user, permission.id) ? 'unchecked' : 'mat-checkbox-checked'"
                      [color]="getCheckBoxColor(users, permission.id, i)"
                      [formControlName]="permission.id"
                      (change)="onUserPermissionChange(users, permission.id, i)"
                    ></mat-checkbox>
                  </ng-template>
                </td>
              </ng-container>

              <!-- Action Column -->
              <ng-container matColumnDef="action">
                <th
                  mat-header-cell
                  *matHeaderCellDef
                  fxFlex
                  fxLayout="row"
                  fxLayoutAlign="end center"
                >
                  Action
                </th>
                <td
                  mat-cell
                  *matCellDef="let user; let i = index;"
                  fxFlex
                  fxLayout="column"
                  fxLayoutAlign="center end"
                  [formGroupName]="i"
                  class="cell-user-action-{{ user.value.id }}"
                >
                  <button
                    *ngIf="currentUserId !== user.value.id"
                    mat-icon-button
                    matTooltip="Delete"
                    matTooltipPosition="before"
                    [disabled]="workspace.isRemovingUserFromWorkspace || isSavingUsersPermissions(users)"
                    (click)="removeUser(user.value.id)"
                    class="action-delete"
                  >
                    <fa-icon icon="trash-alt" class="icon-x1"></fa-icon>
                  </button>
                </td>
              </ng-container>

              <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
              <tr
                mat-row
                *matRowDef="let user; columns: displayedColumns;"
                class="row-{{ user.value.id }} table-row"
              >
              </tr>
            </table>

            <div fxLayout="row" fxLayoutAlign="end center" class="margin-top-x1">
              <button
                mat-raised-button
                type="submit"
                color="primary"
                [disabled]="hasAnyUserChanged() || isSavingUsersPermissions(users)"
                class="btn-save-users-permissions text-upper"
              >
                <span *ngIf="isSavingUsersPermissions(users); else canSave" fxLayout="row" fxLayoutAlign="start center">
                  <mat-spinner [diameter]="16" [strokeWidth]="1" class="margin-right-x1"></mat-spinner>
                  Saving
                </span>

                <ng-template #canSave>
                  <fa-icon icon="check" class="margin-right-x1 icon-x2"></fa-icon>
                  <span class="text-upper">Save</span>
                </ng-template>
              </button>
            </div>
          </form>

        </mat-card-content>
      </mat-card>
    </div>
  </div>
</div>
